﻿using System;

namespace Kruskal
{
    struct Edge : IComparable<Edge>
    {
        public int StartNode { get; set; }

        public int EndNode { get; set; }

        public int Weight { get; set; }

        public int Index { get; set; }

        public int NumberOfRoutes { get; set; }

        public Edge(int startNode, int endNode, int weight, int index) : this()
        {
            this.StartNode = startNode;
            this.EndNode = endNode;
            this.Weight = weight;
            this.Index = index;
        }

        public int CompareTo(Edge other)
        {
            int weightCompared = this.Weight.CompareTo(other.Weight);

            if (weightCompared == 0)
            {
                return this.Index.CompareTo(other.Index);
            }

            return weightCompared;
        }
    }
}
